#include "Status.h"
#include "Vram.h"
#include "Print.h"
#include "Chars.h"
#include "Sprite.h"

constexpr byte Char_Remain = Char_Fighter;

static word PrintS(word vram, ptr<byte> p, bool right)
{
    byte c;
    while ((c = *p) != 0) {
        vram = PrintC(vram, c, right);
        right = !right;
        ++p;
    }
    return vram;
}

void PrintStatus()
{
    PrintS(Vram + VramRowSize * 0 * 2 + WindowWidth / 2, "SCORE", false);
    PrintS(Vram + VramRowSize * 3 * 2 + WindowWidth / 2, "STAGE", false);
    PrintByteNumber2(Vram + VramRowSize * 4 * 2 + (WindowWidth + 4) / 2, CurrentStage + 1, false);
    PrintRemain();
    PrintScore();
}

void PrintScore()
{
    word vram;
    vram = PrintNumber5(Vram + VramRowSize * 1 * 2 + WindowWidth / 2, Score, false);
    PrintC(vram, '0', true);
}

void PrintRemain()
{
    word vram;
    bool right;
    vram = Vram + VramRowSize * 7 * 2 + (WindowWidth + 1) / 2;
    right = true;
    if (RemainCount > 1) {
        byte i;
        i = RemainCount - 1;
        if (i > 2) {
            vram = Put2C(vram, Char_Remain, right);
            vram = Erase2(vram, right);
            vram += VramRowSize - 2 / 2;
            vram = PrintC(vram, i + 0x30, right); right = !right;
            vram += 1 - VramRowSize;
        }
        else {
            do {
                vram = Put2C(vram, Char_Remain, right);
                --i;
            } while (i > 0);
        }
    }
    if (RemainCount < 3) {
        vram = Erase2(vram, right);
    }
}


void PrintGameOver()
{
    constexpr byte Left = (WindowWidth - 8) / 2;
    PrintS(Vram + VramRowSize * 7 + Left / 2, "GAME OVER", false);
    // PresendVram();
}

void Title()
{
    ClearScreen(); 
    HideAllSprites();
    // UpdateSprites();
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            0x0e, 0x05, 0x0b, 0x0c, 
            0x0f, 0x08, 0x0a, 0x0c, 
            0x0f, 0x00, 0x0f, 0x0c, 
            0x04, 0x05, 0x01, 0x00, 
            0x03, 0x0f, 0x0c, 0x07, 
            0x03, 0x0f, 0x0c, 0x03, 
            0x03, 0x0f, 0x0c, 0x03, 
            0x05, 0x01, 0x04, 0x01, 
            0x0b, 0x04, 0x0f, 0x01, 
            0x0f, 0x00, 0x0f, 0x00, 
            0x0f, 0x00, 0x0f, 0x00, 
            0x05, 0x00, 0x05, 0x00, 
            0x0f, 0x0c, 0x03, 0x0e, 
            0x0f, 0x0c, 0x03, 0x0d, 
            0x0f, 0x0c, 0x03, 0x0a, 
            0x04, 0x05, 0x00, 0x04, 
            0x0d, 0x02, 0x00, 0x00, 
            0x0a, 0x00, 0x00, 0x00, 
            0x0c, 0x03, 0x00, 0x00, 
            0x05, 0x00, 0x00, 0x00, 
        };
        constexpr byte LogoLength = 5;
        ptr<byte> p;
        word vram;
        vram = Vram + VramRowSize * 2;
        p = TitleBytes;
        repeat (LogoLength) {
            repeat (4) {
                bool right;
                right = false;
                repeat (4) {
                    vram = Put(vram, *p, right);
                    right = !right;
                    ++p;
                }
                vram += VramRowSize - 2;
            }
            vram += 2 - VramRowSize * 4;
        }
        PrintS(Vram + VramRowSize * 6 + (WindowWidth - 6) / 2, "MINI", false);
    }
    PrintS(Vram + VramRowSize * 10 + (WindowWidth - 14) / 2 / 2, "PUSH SPACE KEY", false);
    PrintS(Vram + VramRowSize * 12 + (WindowWidth - 14) / 2 / 2, "OR RETUAN KEY", false);
    PrintS(Vram + VramRowSize * 14 + (WindowWidth - 12) / 2, "INUFUTO 2023", false);
    // {
    //     byte c;
    //     word vram;
    //     vram = Vram;
    //     c = 0;
    //     repeat (0) {
    //         vram = Put(vram, c);
    //         ++c;
    //         if ((c & 15) == 0) {
    //             vram += VramRowSize - 16;
    //         }
    //     }
    // //     // UpdateEnemyChars();
    // //     // SwitchChars();
    // //     // while (true) {
    // //     //     ++EnemyRowLeft;
    // //     //     UpdateEnemyChars();
    // //     //     SwitchChars();
    // //     //     WaitTimer(30);
    // //     // }
    // }
    // PresendVram();
}


void AddScore(word pts)
{
    Score += pts;
    PrintScore();
}
